'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbfreenotes.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
%UniqueNumber = 1818181818

#Include "cwindow.inc"
#Include "ListViewCtrl.inc"
#Include "HeaderCtrl.inc"

'#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "files\gbfreenotes.ico"
#Resource Icon xdelete "files\delete.ico"
#Resource Icon xview "files\view.ico"
#Resource Icon xsearch "files\search.ico"
#Resource Icon xxprint "files\print.ico"
#Resource Icon xsettings "files\settings.ico"
#Resource Icon xhelp "files\help.ico"
#Resource Icon xopen "files\open.ico"
#Resource Icon xsortup "files\sortascending.ico"
#Resource Icon xsortdown "files\sortdescending.ico"
#Resource Icon xadd "files\add.ico"
#Resource Icon xviewall "files\viewall.ico"
#Resource Icon xemail "files\email.ico"
#Resource Icon aaa "files\download.ico"
#Resource Icon xkey "files\keyb.ico"
#Resource Icon xactions "files\actions.ico"
#Resource Icon xcopy "files\copy.ico"
#Resource Icon xdate "files\date.ico
#Resource Icon xdirty "files\dirty.ico
#Resource Icon xclean "files\clean.ico
#Resource Icon xcollapse "files\collapse.ico
#Resource Icon xbookmark "files\bookmark.ico

%SearchAnyTerm  = 1
%SearchAllTerms = 2
%SearchAsString = 3
$Delimiter = "++-" + "-;;" + $CrLf

Enum Controls Singular
   IDC_ListView = 500
   IDC_Toolbar
   IDC_Statusbar
   IDC_TextBox
   IDC_TreeView
   IDC_Label
   IDC_ComboBox
   IDC_Button
   IDC_Events

   IDS_Next
   IDS_Case
   IDS_Search
   IDS_SearchTerm
   IDS_Label
   IDS_STRING
   IDS_AND
   IDS_OR
   IDS_WholeWord

   IDT_File
   IDT_Add
   IDT_Delete
   IDT_View
   IDT_Collapse
   IDT_ViewAll
   IDT_Find
   IDT_CreateBookmark
   IDT_Email
   IDT_Copy
   IDT_ShowEvents
   IDT_Print
   IDT_SaveEncrypted
   IDT_Actions
   IDT_Settings
   IDT_Help

   IDM_Test
   IDM_AutoSave
   IDM_ConfirmDelete
   IDM_Sep
   IDM_Debug
   IDM_AutoPosition
   IDM_FileInTitle
   IDM_CollapseNodes
   IDM_CollapseExcept
   IDM_ExpandNodes
   IDM_CopyAll
   IDM_Backup
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_ShowBookmarks
   IDM_RemoveAllBookmarks
   IDM_Print                  'whatever is in record Editor
   IDM_EventReport
   IDM_CountReport
   IDM_CloseViewDialogs
   IDM_ShowAllEvents
   IDM_New
   IDM_Save
   IDM_SaveAs
   IDM_Font
   IDM_CloseWindow
   IDM_SetFirstPosition
   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_OpenURL
   IDM_OpenEmail
   IDM_OpenSearch
   IDM_UpdateEXE
   IDM_CaseSensitive
   IDM_WholeWord
   IDM_AutoCheckEvents
   IDM_OnTop
   IDM_GoToSearch
   IDM_ClearFileHistory
   IDM_ClearTermHistory
   IDM_FileMRU1
   IDM_FileMRU2
   IDM_FileMRU3
   IDM_FileMRU4
   IDM_FileMRU5
   IDM_SearchString
   IDM_SearchALL
   IDM_SearchOR
   IDM_AllowANDOR
   IDM_EqualSize
   IDM_WideControls

   IDR_Blog

   FindNext
   FindPrevious

End Enum

%SavedFieldsPerRecord = 5
%EdgeMargin = 40

Type BohoData
   name As String * 50      '<--- 1st col of ListView and in TreeView
   category As String * 50  '<--- TreeView category
   date As String * 20
   node As String * 15      '<--
   flag As String * 1
   blog As String * 5000
End Type

$Ver = "1.2"

Global hDlg, hRecord, hFontA, hFontB, hToolbar, hTree, ghHook, hSearch, hTextBox As Dword
Global hContextTB_Editor, hContextTB_ComboBoxEdit, hContextTB_ViewOnly, hContextTB_Find As Dword
Global hPopupFile, hPopupBookmark, hPopupHelp, hPopupEvents,hPopupTreeView, hPopupSettings, hPopupActions As Dword
Global hComboBox,hComboBoxedit,hPopupListView,hImageListSort As Dword
Global hHeader, hListView, hTxtWin As Dword, SortDirection, EventSortDirection, Debug, AutoPosition As Long
Global D() As BohoData, FileChanged, ConfirmDelete, AllowANDOR, EqualSize, WideControls As Long
Global FileInTitle, WholeWords, FindIsVisible As Long
Global SaveEncrypted, AutoSave, OnTop, AutoCheckEvents, CaseSensitive, SearchMode As Long
Global ValidWordCharacters, SearchTerm, FileName, FontName As WStringZ * %Max_Path
Global FileMRU1, FileMRU2, FileMRU3, FileMRU4, FileMRU5 As WStringZ * %Max_Path
Global TermMRU1, TermMRU2, TermMRU3, TermMRU4, TermMRU5 As WStringZ * %Max_Path
Global FontSize, FontAttr, LastSel, wCol1, wCol2, wCol3, DTag() As Long
Global LastW, LastH, FirstDX, FirstDY, LastDX, LastDY As Long
Global PSW, BigString,RecordHandles As String
Global OldProcTB_Editor, OldProcTB_ViewOnly, OldProcTB_ComboBoxEdit, OldProcTB_Find As Dword
'Global OriginalEditLabelText$

#Include "files\gbonlineupdate.inc"

Function PBMain() As Long
   If InstanceTest = 0 Then Exit Function
   Dialog New Pixels, 0, "gbFreeNotes " + $ver,300,300,310,260, %WS_OverlappedWindow To hDlg
   SetWindowLong(hDlg, %GWL_USERDATA, %UniqueNumber)  '<---- LONG allows up to 10 digits
   Dialog Set Icon hDlg, "logo"
   hUpdateParent = hDlg
   Control Add Label, hDlg, %IDC_Label,"Search Terms:",10,60,90,25
   CreateToolbar
   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
   If RestartUpdate Then RestartUpdatedEXE
End Function

CallBack Function DlgProc() As Long
   Local i,w,h,iResult As Long, P As TooltipText Ptr, temp$, hNode As Dword
   Local LVData As NM_ListView, nmtb As TBNotify Ptr, rc As Rect, pt As Point
   Select Case Cb.Msg
      Case %WM_InitDialog
         If Debug Then Txt.Window "Debug", 300,300,30,40 To hTxtWin
         Settings_INI "get"
         SetDialogTitle
         CreateContextMenus
         CreateComboBox
         CreateTreeView
         CreateListView
         Control Add TextBox, hDlg, %IDC_TextBox,"-", 330,60,200,200, _
            %ES_MultiLine Or %ES_WantReturn Or %WS_TabStop Or %ES_Left Or _
            %ES_AutoVScroll Or %ES_AutoHScroll, %WS_Ex_ClientEdge
         Control Handle hDlg, %IDC_TextBox To hTextBox
         OldProcTB_Editor = SetWindowLong(hTextBox, %GWL_WndProc, CodePtr(TextBoxProc_Editor))   'subclass a control
         Font New "Tahoma",10,0 To hFontA
         Control Set Font hDlg, %IDC_Toolbar, hFontA
         Control Set Font hDlg, %IDC_StatusBar, hFontA
         Control Set Font hDlg, %IDC_Label, hFontA
         Control Set Font hDlg, %IDC_ComboBox, hFontA
         Control Set Font hDlg, %IDC_Button, hFontA
         BuildAcceleratorTable
         LoadDataFromFileToD
         LoadListViewFromD
         SetHeaderIcons 0
         LoadTreeViewFromLV
         LoadTextBoxFromD
         SetMenus
         Font New FontName, FontSize, FontAttr To hFontB
         Control Set Font hDlg, %IDC_ListView, hFontB
         Control Set Font hDlg, %IDC_TreeView, hFontB
         Control Set Font hDlg, %IDC_TextBox, hFontB
         Dialog Post hDlg, %WM_User+500, 0, 0

      Case %WM_User+500
         If Debug Then Txt.Print "%WM_User+500"
         ListView Visible hDlg, %IDC_ListView, LastSel
         ListView Select hDlg, %IDC_ListView, LastSel
         ListView_SetItemState hListView, LastSel-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         ShowSelectionInStatusBar
         ListView Get Text hDlg, %IDC_ListView, LastSel, 3 To temp$  'TreeView node
         Treeview Select hDlg, %IDC_TreeView, Val(temp$)
         SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
         If AutoCheckEvents Then DisplayEvents
         Control Set Focus hDlg, %IDC_ListView
         Control Set Focus hDlg, %IDC_ComboBox
         SetDirty
         SetHeaderTitle
         CollapseAllNodes

      Case %WM_User+501
         Control Set Focus hDlg, %IDC_ListView

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_ComboBox
               Select Case Cb.CtlMsg
                  Case %CBN_SelChange
                     Control Send hDlg, %IDC_ComboBox, %CB_GetCurSel, 0, 0 To iResult
                     ComboBox Get Text hDlg, %IDC_ComboBox, iResult+1 To SearchTerm
                     FindSearchTerm
               End Select
            Case %IDC_Button
               Control Get Text hDlg, %IDC_ComboBox To SearchTerm
               FindSearchTerm
            Case %IDC_TextBox
               Select Case Cb.CtlMsg
                  Case %EN_Change : ApplyChanges
'                  Case %EN_SetFocus : Control Send hDlg, %IDC_TextBox, %EM_SetSel, 0, 0
               End Select

            Case %IDT_File       : OpenDataBase
            Case %IDM_New        : NewDataBase
            Case %IDM_Save
               If SaveEncrypted And GetPSW("Save File")=0 Then Exit Select
               SaveDToFile
               FileChanged = 0 : SetDirty
               Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Database saved ... " + Date$ + "  " + Time$
            Case %IDM_SaveAs     : SaveDToFileAs
            Case %IDT_Add        : AddNewRecord
            Case %IDT_Delete
               Select Case GetFocus
                  Case hListView     : DeleteCheckedRecords
'                  Case hTextBox      : SendMessage hTextBox, %WM_CLEAR, 0, 0
'                  Case hComboBoxEdit : SendMessage hComboBoxEdit, %WM_CLEAR, 0, 0
                  Case Else          : SendMessage GetFocus, %WM_CLEAR, 0, 0
               End Select
            Case %IDT_View       : ViewSelectedRecord
            Case %IDT_ViewAll    : ViewAllRecords

            Case %IDT_ShowEvents  : DisplayEvents
            Case %IDM_ShowAllEvents : DisplayAllEvents
            Case %IDM_CountReport : DisplayCount

            Case %IDT_Find
               If FindIsVisible = 0 Then FindIsVisible = 1 : DisplayFindDialog
            Case %IDT_Email      : SendEmail
            Case %IDM_Font       : SelectMainFont
            Case %IDM_EventReport : DisplayEvents
            Case %IDM_Countreport : DisplayCount

            Case %IDM_CloseWindow
               Dialog End GetParent(GetFocus)

            Case %IDM_SetFirstPosition
               Dialog Get Loc GetParent(GetFocus) To FirstDX, FirstDY

            Case %IDM_CloseViewDialogs, %IDT_Actions
               iResult = ParseCount(RecordHandles,$Spc)
               For i = 1 To iResult
                  Dialog End Val(Parse$(RecordHandles,$Spc,i))
               Next i
               LastDX = FirstDX-40 : LastDY = FirstDY-10
               Reset RecordHandles

            Case %IDT_Help
               iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbfreenotes.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_Test : RunTest

            Case %IDM_CaseSensitive : CaseSensitive = CaseSensitive Xor 1 : SetMenus
            Case %IDM_WholeWord     : WholeWords = WholeWords Xor 1 : SetMenus

            Case %IDM_SearchString  : SearchMode = %SearchAsString : SetMenus
            Case %IDM_SearchOR      : SearchMode = %SearchAnyTerm  : SetMenus
            Case %IDM_SearchALL     : SearchMode = %SearchAllTerms : SetMenus

            Case %IDM_AllowANDOR    : AllowANDOR = AllowANDOR Xor 1 : SetMenus
            Case %IDM_EqualSize     : EqualSize = EqualSize Xor 1 : SetMenus : ResizeWindow
            Case %IDM_WideControls  : WideControls = WideControls Xor 1 : SetMenus : ResizeWindow

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_OpenURL : OpenURL
            Case %IDM_OpenEmail : OpenEmail
            Case %IDM_OpenSearch : OpenSearch

            Case %IDM_CollapseNodes, %IDT_Collapse  : CollapseAllNodes
            Case %IDM_ExpandNodes    : ExpandAllNodes
            Case %IDM_CollapseExcept : CollapseExcept

            Case %IDM_Print, %IDT_Print : PrintSelectionOrAll
            Case %IDM_CopyAll, %IDT_Copy : CopySelectionOrAll

            Case %IDM_Backup        : BackupDataBase

            Case %IDM_CheckAll      : CheckAll
            Case %IDM_UnCheckAll    : UnCheckAll

            Case %IDT_CreateBookmark  : CreateBookmark
            Case %IDM_ShowBookmarks   : ShowBookmarks
            Case %IDM_RemoveAllBookmarks : RemoveAllBookmarks

'            Case %IDM_EditLabel     : SetFocus hTree : TreeEditLabel

            Case %IDM_FileInTitle   : FileInTitle = FileInTitle Xor 1 : SetMenus : SetDialogTitle

            Case %IDM_ConfirmDelete : ConfirmDelete = ConfirmDelete Xor 1 : SetMenus
            Case %IDM_AutoSave      : AutoSave = AutoSave Xor 1 : SetMenus
            Case %IDM_AutoCheckEvents : AutoCheckEvents = AutoCheckEvents Xor 1 : SetMenus

            Case %IDM_ClearFileHistory      : Reset FileMRU1,FileMRU2,FileMRU3,FileMRU4,FileMRU5
            Case %IDM_FileMRU1 To %IDM_FileMRU5 : TakeFileMRUAction(Cb.Ctl)

            Case %IDM_ClearTermHistory : ComboBox Reset hDlg, %IDC_ComboBox

            Case %IDM_GoToSearch
               Control Set Focus hDlg, %IDC_ComboBox

            Case %IDM_OnTop, %IDT_Settings
               OnTop = OnTop Xor 1
               If OnTop Then
                  SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)  'on Top
               Else
                  SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE) 'not on Top
               End If
               SetMenus
            Case %IDT_SaveEncrypted
               SaveEncrypted = SaveEncrypted Xor 1
               FileChanged = 1 : SetDirty
               SetMenus

            Case %IDM_UpdateEXE
               CheckForEXEUpdates($Ver)

            Case %IDM_AutoPosition : AutoPosition = AutoPosition Xor 1 : SetMenus

            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  Txt.Window "Debug", 300,300,40,40 To hTxtWin
               Else
                  Txt.End
               End If

            Case %IdOk
               Select Case GetFocus
                  Case hListView
                     ViewSelectedRecord
                  Case hComboBoxEdit
                     ComboBoxSet_Pierre
                     Control Get Text hDlg, %IDC_ComboBox To SearchTerm
                     FindSearchTerm
               End Select
            Case %IdCancel
               Dialog End hSearch
         End Select

      Case %WM_LButtonUp
         pt.x = Lo(Word,Cb.LParam) : pt.y = Hi(Word,Cb.LParam)
         If pt.x < 71 Then
            If pt.y < 160 Then CollapseAllNodes Else ExpandAllNodes
         End If


      Case %WM_ContextMenu
         Select Case GetDlgCtrlID (Cb.WParam)
            Case %IDC_ListView
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then TrackPopupMenu hPopupListView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
            Case %IDC_TreeView
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
               ListView Get Select hDlg, %IDC_ListView To iResult
               Treeview Get Select hDlg, %IDC_TreeView To hNode
               Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
               If iResult And hNode Then TrackPopupMenu hPopupTreeView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_File
                       BuildFileHistoryMenu
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupFile, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Actions
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupActions, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_CreateBookmark
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupBookmark, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_ShowEvents
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupEvents, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Help
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

         Select Case Cb.NmId
            Case %IDC_StatusBar
               If Cb.NmCode = %NM_DblClk Then FakeData
            Case %IDT_File To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                      P = Cb.LParam
                      @P.@lpszText = SetToolTips(Cb.NmId)
               End Select
            Case %IDC_TreeView
               Select Case Cb.NmCode
                  Case %TVN_SelChangedW, %NM_SetFocus

                     If GetFocus = hTree Then
                        Treeview Get Select hDlg, %IDC_TreeView To hNode
                        Treeview Get User hDlg, %IDC_TreeView, hNode To iResult
                        ListView Select hDlg, %IDC_ListView, iResult
                        ListView Visible hDlg, %IDC_ListView, iResult
                        ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                        LoadTextBoxFromD
                     End If
                  Case %NM_DblClk
                     Treeview Get Select hDlg, %IDC_TreeView To hNode
                     Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
                     If hNode Then
                        ViewSelectedRecord
                     End If

               End Select

            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged, %NM_SetFocus
                     ShowSelectioninStatusBar
                     If GetFocus = hListView Then
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        ListView Get Text hDlg, %IDC_ListView, iResult, 3 To temp$  'TreeView node
                        Treeview Select hDlg, %IDC_TreeView, Val(temp$)
                        SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
                        LoadTextBoxFromD
                     End If
                  Case %NM_DblClk
                     ViewSelectedRecord
                  Case %LVN_ColumnClick
                     ListView Get Select hDlg, %IDC_Listview To iResult
                     ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$  'array POS
                     ReDim DTag(UBound(D))
                     DTag(Val(temp$)) = 1

                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection = SortDirection Xor 1
                     If LVData.iSubItem+1 < 2 Then
                        Select Case LVData.iSubItem+1
                            Case 1 'name
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByNameA()
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByNameD()
                        End Select
                        FileChanged = 1 : SetDirty
                        SetHeaderIcons LVData.iSubItem
                        LoadListViewFromD
                        LoadTreeViewFromLV
                        LoadTextBoxFromD

                        'get new position of DTag() that was set to 1
                        For i = 1 To UBound(DTag)
                           If DTag(i) Then w = i : Exit For
                        Next i

                        'select the ListView row containing w in POS column
                        ListView Get Count hDlg, %IDC_ListView To iResult
                        For i = 1 To iResult
                           ListView Get Text hDlg, %IDC_ListView, i, 2 To temp$  'array pos
                           If Val(temp$) = w Then
                              ListView Select hDlg, %IDC_ListView, i
                              ListView Visible hDlg, %IDC_ListView, i
                              ListView_SetItemState hListView, i-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                              Exit For
                           End If
                        Next i
                        ShowSelectionInStatusBar
                        SelectTVFromLV
                     End If
               End Select
         End Select
      Case %WM_Size
         ReSizeWindow
      Case %WM_SysCommand
         If Debug Then Txt.Print "%WM_SysCommand"
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
            If FileChanged Then
               If AutoSave Then
                  If SaveEncrypted And GetPSW("Save File")=0 Then Function = 1 : Exit Select 'abort save, abort close
                  SaveDToFile
               Else
                  Select Case MsgBoxX("Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Close Application")
                     Case %IdYes
                        If SaveEncrypted And GetPSW("Save File")=0 Then Function = 1 : Exit Select 'abort save, abort close
                        SaveDToFile
                     Case %IdNo
                        'no action. close without saving changes
                     Case %IdCancel
                        Function = 1 'abort close - return to application
                  End Select
               End If
            End If
         End If
      Case %WM_Destroy
         SetWindowLong hTextBox, %GWL_WNDPROC, OldProcTB_Editor   'un-subclass, restore original window procedure
         SetWindowLong hComboBoxEdit, %GWL_WNDPROC, OldProcTB_ComboBoxEdit   'un-subclass, restore original window procedure
         ListView Get Select hDlg, %IDC_ListView To LastSel
         ListView Get Column hDlg, %IDC_ListView, 1 To wCol1
         ListView Get Column hDlg, %IDC_ListView, 2 To wCol2
         ListView Get Column hDlg, %IDC_ListView, 3 To wCol3
         ComboBox Get Text hDlg, %IDC_ComboBox, 1 To TermMRU1
         ComboBox Get Text hDlg, %IDC_ComboBox, 2 To TermMRU2
         ComboBox Get Text hDlg, %IDC_ComboBox, 3 To TermMRU3
         ComboBox Get Text hDlg, %IDC_ComboBox, 4 To TermMRU4
         ComboBox Get Text hDlg, %IDC_ComboBox, 5 To TermMRU5
         Settings_INI "save"
   End Select
End Function

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(13)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help         : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDT_Find         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDT_Delete       : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Delete : ac(c).cmd   = %IDT_Delete      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDT_Find         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G      : ac(c).cmd   = %IDM_GoToSearch   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L      : ac(c).cmd   = %IDT_ViewAll      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDM_WideControls : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N      : ac(c).cmd   = %IDT_Add          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P      : ac(c).cmd   = %IDM_Print        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R      : ac(c).cmd   = %IDM_CountReport  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDM_Save         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_Test         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W      : ac(c).cmd   = %IDM_CloseViewDialogs : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Y      : ac(c).cmd   = %IDM_Debug        : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub LoadListViewFromD
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount As Long
SendMessage hListView, %WM_SetRedraw, 0, 0
   ListView Reset hDlg, %IDC_ListView
   If UBound(D) = 0 Then
SendMessage hListView, %WM_SetRedraw, 1, 0
       Exit Sub
   End If
   For iPos = 1 To UBound(D)
      If D(iPos).flag = "1" Then
         Incr iCount
         ListView Insert Item hDlg, %IDC_ListView, iCount, 0, Trim$(D(iPos).name)
         ListView Set Text hDlg, %IDC_ListView, iCount, 2, Trim$(Str$(iPos))
         ListView Set Text hDlg, %IDC_ListView, iCount, 3, Trim$(D(iPos).node)
      End If
   Next iPos
   ListView Select hDlg, %IDC_ListView, 1
   ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
SendMessage hListView, %WM_SetRedraw, 1, 0
   ShowSelectionInStatusBar
End Sub

Sub CreateToolbar
   If Debug Then Txt.Print FuncName$
   Local hImageList, hImageListDisabled As Dword

   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "xopen"     '1
   ImageList Add Icon hImageList, "xadd"      '2
   ImageList Add Icon hImageList, "xdelete"   '3
   ImageList Add Icon hImageList, "xview"     '4
   ImageList Add Icon hImageList, "xviewall"  '5
   ImageList Add Icon hImageList, "xsearch"   '6
   ImageList Add Icon hImageList, "xxprint"   '7
   ImageList Add Icon hImageList, "xemail"    '8
   ImageList Add Icon hImageList, "xactions"  '9
   ImageList Add Icon hImageList, "xkey"      '10
   ImageList Add Icon hImageList, "xsettings" '11
   ImageList Add Icon hImageList, "xhelp"     '12
   ImageList Add Icon hImageList, "xcopy"     '13
   ImageList Add Icon hImageList, "xdate"     '14
   ImageList Add Icon hImageList, "xdirty"    '15
   ImageList Add Icon hImageList, "xclean"    '16
   ImageList Add Icon hImageList, "xcollapse" '17
   ImageList Add Icon hImageList, "xbookmark" '18


   ImageList New Icon 24,24,24,1 To hImageListDisabled
   ImageList Add Icon hImageListDisabled, "xgray"     '1

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0             'default imagelist
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListDisabled, 1     'disabled imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_File,  %TbStyle_Button Or %TbStyle_DropDown, "File"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Add,  %TbStyle_Button, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Delete,  %TbStyle_Button,"Delete"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_View,  %TbStyle_Button, "View"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDT_Collapse,  %TbStyle_Button, "Collapse"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_ViewAll,  %TbStyle_Button, "View All"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Find,  %TbStyle_Button, "Find"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Copy,  %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Print,  %TbStyle_Button, "Print"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Email,  %TbStyle_Button, "Email"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_CreateBookmark,  %TbStyle_Button Or %TbStyle_DropDown, "Bookmark"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_ShowEvents,  %TbStyle_Button Or %TbStyle_DropDown, "Events"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Actions,  %TbStyle_Button Or %TbStyle_DropDown, "Actions"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_SaveEncrypted,  %TbStyle_Check, "Encrypt"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Help,  %TbStyle_Button Or %TbStyle_DropDown, "Help"
End Sub

Sub SelectMainFont
   If Debug Then Txt.Print FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFontB
      Control Set Font hDlg, %IDC_ListView, hFontB
      Control Set Font hDlg, %IDC_TreeView, hFontB
      Control Set Font hDlg, %IDC_TextBox, hFontB
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "860", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height
      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "noname.txt", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Searchterm", "Gary", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ValidWordCharacters", Chr$(48 To 57, 65 To 90, 95, 97 To 122), ValidWordCharacters, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileMRU1", "", FileMRU1, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileMRU2", "", FileMRU2, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileMRU3", "", FileMRU3, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileMRU4", "", FileMRU4, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileMRU5", "", FileMRU5, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TermMRU1", "Gary", TermMRU1, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TermMRU2", "John", TermMRU2, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TermMRU3", "Paul", TermMRU3, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TermMRU4", "", TermMRU4, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TermMRU5", "", TermMRU5, %Max_Path, INIFileName


      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "LastSel", "1", temp, %Max_Path, INIFileName:  LastSel = Val(temp)
      Getprivateprofilestring "All", "ConfirmDelete", "1", temp, %Max_Path, INIFileName:  ConfirmDelete = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName:  AutoSave = Val(temp)
      Getprivateprofilestring "All", "FileInTitle", "1", temp, %Max_Path, INIFileName:  FileIntitle = Val(temp)
      Getprivateprofilestring "All", "SaveEncrypted", "0", temp, %Max_Path, INIFileName:  SaveEncrypted = Val(temp)
      Getprivateprofilestring "All", "OnTop", "0", temp, %Max_Path, INIFileName:  OnTop = Val(temp)
      Getprivateprofilestring "All", "AutoCheckEvents", "0", temp, %Max_Path, INIFileName:  AutoCheckEvents = Val(temp)
      Getprivateprofilestring "All", "AutoPosition", "1", temp, %Max_Path, INIFileName:  AutoPosition = Val(temp)
      Getprivateprofilestring "All", "Case Sensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "SearchMode", Str$(%SearchAsString), temp, %Max_Path, INIFileName:  SearchMode = Val(temp)
      Getprivateprofilestring "All", "WholeWords", "0", temp, %Max_Path, INIFileName  :  WholeWords = Val(temp)
      Getprivateprofilestring "All", "AllowANDOR", "1", temp, %Max_Path, INIFileName  :  AllowANDOR = Val(temp)
      Getprivateprofilestring "All", "EqualSize", "0", temp, %Max_Path, INIFileName  :  EqualSize = Val(temp)
      Getprivateprofilestring "All", "WidtControls", "1", temp, %Max_Path, INIFileName  :  WideControls = Val(temp)
      Getprivateprofilestring "All", "FirstDX", "100", temp, %Max_Path, INIFileName  :  FirstDX = Val(temp)
      Getprivateprofilestring "All", "FirstDY", "-300", temp, %Max_Path, INIFileName  :  FirstDY = Val(temp)
      Getprivateprofilestring "All", "SortDirection", "0", temp, %Max_Path, INIFileName  :  SortDirection = Val(temp)

      Getprivateprofilestring "All", "wCol1", "145",  temp, %Max_Path, INIFileName:  wCol1 = Val(temp)  'name
      Getprivateprofilestring "All", "wCol2", "0",  temp, %Max_Path, INIFileName:  wCol2 = Val(temp)  'phone
      Getprivateprofilestring "All", "wCol3", "0",  temp, %Max_Path, INIFileName:  wCol3 = Val(temp)  'email

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "ValidWordCharacters",ValidWordCharacters, INIFileName
      WritePrivateProfileString "All", "FileMRU1",FileMRU1, INIFileName
      WritePrivateProfileString "All", "FileMRU2",FileMRU2, INIFileName
      WritePrivateProfileString "All", "FileMRU3",FileMRU3, INIFileName
      WritePrivateProfileString "All", "FileMRU4",FileMRU4, INIFileName
      WritePrivateProfileString "All", "FileMRU5",FileMRU5, INIFileName
      WritePrivateProfileString "All", "TermMRU1",TermMRU1, INIFileName
      WritePrivateProfileString "All", "TermMRU2",TermMRU2, INIFileName
      WritePrivateProfileString "All", "TermMRU3",TermMRU3, INIFileName
      WritePrivateProfileString "All", "TermMRU4",TermMRU4, INIFileName
      WritePrivateProfileString "All", "TermMRU5",TermMRU5, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "LastSel", (Str$(LastSel)), INIFileName
      WritePrivateProfileString "All", "ConfirmDelete", (Str$(ConfirmDelete)), INIFileName
      WritePrivateProfileString "All", "AutoSave", (Str$(AutoSave)), INIFileName
      WritePrivateProfileString "All", "FileInTitle", (Str$(FileInTitle)), INIFileName
      WritePrivateProfileString "All", "SaveEncrypted", (Str$(SaveEncrypted)), INIFileName
      WritePrivateProfileString "All", "OnTop", (Str$(OnTop)), INIFileName
      WritePrivateProfileString "All", "AutoCheckEvents", (Str$(AutoCheckEvents)), INIFileName
      WritePrivateProfileString "All", "AutoPosition", (Str$(AutoPosition)), INIFileName
      WritePrivateProfileString "All", "Case Sensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "SearchMode", (Str$(SearchMode)), INIFileName
      WritePrivateProfileString "All", "WholeWords", (Str$(WholeWords)), INIFileName
      WritePrivateProfileString "All", "AllowANDOR", (Str$(AllowANDOR)), INIFileName
      WritePrivateProfileString "All", "EqualSize", (Str$(EqualSize)), INIFileName
      WritePrivateProfileString "All", "WideControls", (Str$(WideControls)), INIFileName
      WritePrivateProfileString "All", "FirstDX", (Str$(FirstDX)), INIFileName
      WritePrivateProfileString "All", "FirstDY", (Str$(FirstDY)), INIFileName
      WritePrivateProfileString "All", "SortDirection", (Str$(SortDirection)), INIFileName

      WritePrivateProfileString "All", "wCol1", (Str$(wCol1)), INIFileName
      WritePrivateProfileString "All", "wCol2", (Str$(wCol2)), INIFileName
      WritePrivateProfileString "All", "wCol3", (Str$(wCol3)), INIFileName
   End If
End Sub

Sub AddNewRecord
   Local iPos, iResult As Long, temp$
   'current selection
   ListView Get Select hDlg, %IDC_ListView To iResult
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$  'array pois
   iPos = Val(temp$)
   'new item in array
   ReDim Preserve D(UBound(D)+1)
   D(UBound(D)).name = "<new name>"
   D(UBound(D)).category = D(iPos).category
   D(UBound(D)).date = CDate
   D(UBound(D)).flag = "1"
   D(UBound(D)).node = "-"
   D(UBound(D)).blog = "-"
   FileChanged = 1 : SetDirty
   'rebuild displays
   LoadListViewFromD
   LoadTreeViewFromLV
   LoadTextBoxFromD
   'select
   ListView Get Count hDlg, %IDC_ListView To iResult
   ListView Select hDlg, %IDC_ListView, iResult
   ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   ShowSelectionInStatusBar
   SelectTVFromLV
End Sub

Sub DeleteCheckedRecords
   If Debug Then Txt.Print FuncName$
   Local i,iPos,iCount,iSelected,iDeleteCount,iDeletedBelow,iDeleted,LastDeletedPos As Long, temp$
   If GetFocus <> hListView Then Exit Sub

   'see if there are any items checked. if not, exit
   ListView Get Count hDlg, %IDC_ListView To iCount
   ListView Get Select hDlg, %IDC_ListView To iSelected

   For iPos = 1 To iCount
      If ListView_GetCheckState(hListView,iPos-1) And iPos <> iSelected Then Incr iDeleteCount
   Next
   iDeleteCount = iDeleteCount + IIf(iSelected,1,0)
   If iDeleteCount = 0 Then Beep : Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "No Notes checked/selected ..." : Exit Sub


   'confirm delete, as required by setting
   If ConfirmDelete Then
      If MsgBoxX("Delete " + Str$(iDeleteCount) + " checked/selected Notes?", %MB_OkCancel + %MB_IconQuestion, "Delete") = %IdCancel Then
         Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "Delete cancelled ..."
         Beep : Exit Sub : End If
   End If

   'delete selected
   If iSelected Then
      ListView Get Text hDlg, %IDC_ListView, iSelected, 2 To temp$   'array pos
      iPos = Val(temp$)
      Array Delete D(iPos) : Incr iDeleted : LastDeletedPos = iPos
      ListView Delete Item hDlg, %IDC_ListView, iSelected
   End If

   'delete checked, starting at end of list
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = iCount To 1 Step - 1
      If ListView_GetCheckState(hListView,i-1) Then
         If i < iSelected Then Incr iDeletedBelow
         ListView Get Text hDlg, %IDC_ListView, i, 2 To temp$  'array position
         iPos = Val(temp$)
         Array Delete D(iPos) : Incr iDeleted : LastDeletedPos = i
      End If
   Next i

   'resize D(), show results in ListView
   FileChanged = 1 : SetDirty
   ReDim Preserve D(0 To UBound(D)-iDeleted)
   LoadListViewFromD
   LoadTreeViewFromLV
   LoadTextBoxFromD

   If iSelected Then
      LastDeletedPos = iSelected - iDeletedBelow
      If LastDeletedPos > UBound(D) Then LastDeletedPos = UBound(D)
      ListView Select hDlg, %IDC_ListView, LastDeletedPos
      ListView_SetItemState hListView, LastDeletedPos-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
      ListView Visible hDlg, %IDC_ListView, LastDeletedPos
      Control Set Focus hDlg, %IDC_ListView
   End If
   ShowSelectionInStatusBar
   SelectTVFromLV
End Sub

Sub ViewSelectedRecord
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, temp$, title$
   ListView Get Select hDlg, %IDC_ListView, 1 To iPos
   If iPos = 0 Then Beep : Exit Sub
   ListView Get Text hDlg, %IDC_ListView, iPos, 2 To temp$  'array POS
   ListView Get Text hDlg, %IDC_ListView, iPos, 1 To title$ 'name
   DisplayRecordDialog(title$, Val(temp$),0)
End Sub

Sub ShowSelectioninStatusBar
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount As Long, temp$

   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Database is empty!"
      Exit Sub
   End If

   ListView Get Select hDlg, %IDC_ListView To iPos
   If iPos Then
      ListView Get Text hDlg, %IDC_ListView, iPos, 2 To temp$  'array POS
      iPos = Val(temp$)
      If Len(Trim$(D(iPos).name))     Then temp$ = Trim$(D(iPos).name) Else temp$ = "<no name>"
      If Len(Trim$(D(iPos).category)) Then temp$ = temp$ + "  :  " + Trim$(D(iPos).category)  Else temp$ = temp$ + "  :  <no category>"
      If Len(Trim$(D(iPos).date))     Then temp$ = temp$ + "  :  " + Trim$(D(iPos).date)
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, temp$ 'RecordText(iPos," : ")
   Else
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, ""
   End If
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_File       : Function = "Open Existing Database File"

      Case %IDT_Add        : Function = "Add New Note"
      Case %IDT_Delete     : Function = "Delete Checked or Selected Notes"
      Case %IDT_View       : Function = "View selected Notes"

      Case %IDT_Collapse   : Function = "Collapse All Categories"
      Case %IDT_ViewAll    : Function = "View All Notes in ListView"
      Case %IDT_Find       : Function = "Open Find Dialog"

      Case %IDT_Copy       : Function = "Copy Editor Selection (All If No Selection)"
      Case %IDT_Email      : Function = "Send Email"
      Case %IDT_ShowEvents : Function = "Show Event Report
      Case %IDT_Print      : Function = "Print Editor Selection (All if No Selection)"
      Case %IDT_Actions    : Function = "Send Text Message"

      Case %IDT_SaveEncrypted : Function = "Encrypt File on Save"

      Case %IDT_Settings   : Function = "On Top"
      Case %IDT_Help       : Function = "Open Help dialog"
   End Select
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   If Debug Then Txt.Print FuncName$
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub RunTest
  If Debug Then Txt.Print FuncName$
  FakeData
End Sub

Sub CreateContextMenus
    If Debug Then Txt.Print FuncName$

    Menu New PopUp To hPopupHelp
    Menu Add String, hPopupHelp, "Online Update", %IDM_UpdateEXE, %MF_Enabled

    Menu New PopUp To hPopupEvents
    Menu Add String, hPopupEvents, "Show All Events", %IDM_ShowAllEvents, %MF_Enabled

    Menu New PopUp To hPopupBookmark
    Menu Add String, hPopupBookmark, "Clear All Bookmarks",  %IDM_RemoveAllBookmarks,  %MF_Enabled
    Menu Add String, hPopupBookmark, "Show All Bookmarks",  %IDM_ShowBookmarks,  %MF_Enabled

    Menu New PopUp To hPopupFile
    Menu Add String, hPopupFile, "New", %IDM_New, %MF_Enabled
    Menu Add String, hPopupFile, "Save", %IDM_Save, %MF_Enabled
    Menu Add String, hPopupFile, "Save As", %IDM_SaveAs, %MF_Enabled
    Menu Add String, hPopupFile, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupFile, "Back Up", %IDM_Backup, %MF_Enabled

    Menu New PopUp To hPopupActions
    Menu Add String, hPopupActions, "Select Font", %IDM_Font, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Display Event Report", %IDM_EventReport, %MF_Enabled
    Menu Add String, hPopupActions, "Display Node Count Report", %IDM_CountReport, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Close View Dialogs", %IDM_CloseViewDialogs, %MF_Enabled
    Menu Add String, hPopupActions, "Clear File History", %IDM_ClearFileHistory, %MF_Enabled
    Menu Add String, hPopupActions, "Clear Search Term History", %IDM_ClearTermHistory, %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Confirm Delete", %IDM_ConfirmDelete, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSave On Exit", %IDM_AutoSave, %MF_Enabled
    Menu Add String, hPopupSettings, "FileName In Title", %IDM_FileInTitle, %MF_Enabled
    Menu Add String, hPopupSettings, "On Top", %IDM_OnTop, %MF_Enabled
    Menu Add String, hPopupSettings, "Resize All Controls", %IDM_EqualSize, %MF_Enabled
    Menu Add String, hPopupSettings, "Event Report on Startup", %IDM_AutoCheckEvents, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoPosition View Dialogs", %IDM_AutoPosition, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Case Sensitive Search", %IDM_CaseSensitive, %MF_Enabled
    Menu Add String, hPopupSettings, "Whole Word Search", %IDM_WholeWord, %MF_Enabled
    Menu Add String, hPopupSettings, "Allow AND/OR Search", %IDM_AllowANDOR, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Search As String", %IDM_SearchString, %MF_Enabled
    Menu Add String, hPopupSettings, "Search Any Term", %IDM_SearchOR, %MF_Enabled
    Menu Add String, hPopupSettings, "Search All Terms", %IDM_SearchALL, %MF_Enabled

    Menu New PopUp To hContextTB_Editor
    Menu Add String, hContextTB_Editor, "Copy",   %IDM_Copy,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Cut",    %IDM_Cut,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Paste",  %IDM_Paste,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Delete", %IDM_Delete,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Open Selection AS URL",  %IDM_OpenURL,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Send Selection As Email",  %IDM_OpenEmail,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_Editor, "Search For Selection",  %IDM_OpenSearch,  %MF_Enabled

    Menu New PopUp To hContextTB_ViewOnly
    Menu Add String, hContextTB_ViewOnly, "Copy",   %IDM_Copy,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "Close Window",   %IDM_CloseWindow,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "Close All Windows",   %IDM_CloseViewDialogs,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "Use As First Position",   %IDM_SetFirstPosition,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "Open Selection AS URL",  %IDM_OpenURL,  %MF_Enabled
    Menu Add String, hContextTB_ViewOnly, "Send Selection As Email",  %IDM_OpenEmail,  %MF_Enabled

    Menu New PopUp To hContextTB_Find
    Menu Add String, hContextTB_Find, "Copy",   %IDM_Copy,  %MF_Enabled
    Menu Add String, hContextTB_Find, "Cut",    %IDM_Cut,  %MF_Enabled
    Menu Add String, hContextTB_Find, "Paste",  %IDM_Paste,  %MF_Enabled
    Menu Add String, hContextTB_Find, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_Find, "Delete", %IDM_Delete,  %MF_Enabled

    Menu New PopUp To hContextTB_ComboBoxEdit
    Menu Add String, hContextTB_ComboBoxEdit, "Copy",   %IDM_Copy,  %MF_Enabled
    Menu Add String, hContextTB_ComboBoxEdit, "Cut",    %IDM_Cut,  %MF_Enabled
    Menu Add String, hContextTB_ComboBoxEdit, "Paste",  %IDM_Paste,  %MF_Enabled
    Menu Add String, hContextTB_ComboBoxEdit, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB_ComboBoxEdit, "Delete", %IDM_Delete,  %MF_Enabled

    Menu New PopUp To hPopupListView
    Menu Add String, hPopupListView, "Check All",  %IDM_CheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "UnCheck All",  %IDM_UnCheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupListView, "Copy", %IDM_CopyAll, %MF_Enabled
    Menu Add String, hPopupListView, "Print", %IDM_Print, %MF_Enabled

    Menu New PopUp To hPopupTreeView
    Menu Add String, hPopupTreeView, "Expand All Categories", %IDM_ExpandNodes, %MF_Enabled
    Menu Add String, hPopupTreeView, "Collapse All Categories", %IDM_CollapseNodes, %MF_Enabled
    Menu Add String, hPopupTreeView, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupTreeView, "Collapse All Other Categories", %IDM_CollapseExcept, %MF_Enabled
    Menu Add String, hPopupTreeView, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupTreeView, "Copy", %IDM_CopyAll, %MF_Enabled
    Menu Add String, hPopupTreeView, "Print", %IDM_Print, %MF_Enabled

    ImageList New Icon 16,16,24,2 To hImageListSort
    ImageList Add Icon hImageListSort, "xsortup"   '1
    ImageList Add Icon hImageListSort, "xsortdown" '2
End Sub

Sub SetMenus
   If Debug Then Txt.Print FuncName$
    'Toolbars
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveEncrypted, %TBState_Checked * SaveEncrypted Or %TBState_Enabled

    'menus
    Menu Set State hPopupSettings, ByCmd %IDM_ConfirmDelete, ConfirmDelete * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_FileInTitle, FileInTitle * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_OnTop, OnTop * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoCheckEvents, AutoCheckEvents * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoPosition, AutoPosition * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_CaseSensitive, CaseSensitive * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_WholeWord, WholeWords * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AllowANDOR, AllowANDOR * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_EqualSize, EqualSize * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupSettings, ByCmd %IDM_SearchString, %MFS_Enabled
    Menu Set State hPopupSettings, ByCmd %IDM_SearchALL, %MFS_Enabled
    Menu Set State hPopupSettings, ByCmd %IDM_SearchOR, %MFS_Enabled
    Select Case SearchMode
      Case %SearchAsString : Menu Set State hPopupSettings, ByCmd %IDM_SearchString, %MFS_Enabled Or %MFS_Checked
      Case %SearchAnyTerm  : Menu Set State hPopupSettings, ByCmd %IDM_SearchOR, %MFS_Enabled Or %MFS_Checked
      Case %SearchAllTerms : Menu Set State hPopupSettings, ByCmd %IDM_SearchALL, %MFS_Enabled Or %MFS_Checked
   End Select
End Sub

Sub FakeData
   If Debug Then Txt.Print FuncName$
   Local i As Long
   If MsgBoxX("Build sample data (will overwrite existing content)?", %MB_OkCancel + %MB_IconQuestion, "Build Sample Data") = %IdCancel Then Exit Sub

   Select Case MsgBoxX("Build small sample database?",%MB_YesNoCancel + %MB_IconQuestion, "Build Fake DataBase")
      Case %IdNo
         ListView Reset hDlg, %IDC_ListView
         ReDim D(0 To 1000)
         D(0).name = "-"
         D(0).category = "-"
         D(0).date = "-"
         D(0).flag = "-"
         D(0).node = "-"
         D(0).blog = "-"

         For i = 1 To 1000
            D(i).name = "Name " + Format$(Rnd(1,1000),"000")
            D(i).category = "Category " + Format$(Rnd(1,10),"00")
            D(i).date = CDate
            D(i).flag = "1"
            D(i).node = "-"
            D(i).blog = "Blog " + Format$(Rnd(1,1000),"000")
         Next i
      Case %IdYes
         ListView Reset hDlg, %IDC_ListView
         ReDim D(0 To 6)
         D(0).name = "-"
         D(0).category = "-"
         D(0).date = "-"
         D(0).flag = "-"
         D(0).node = "-"
         D(0).blog = "-"

         D(1).name = "John Gleason"
         D(1).category = "Co-Worker"
         D(1).date =  "2012-01-10 10:29:00"
         D(1).flag = "1"
         D(1).node = "-"
         D(1).blog = "A cold country where" + $CrLf + "WereWolves reign (well" + $CrLf + "known football team)!" + $CrLf + "Event: Bday 12-11-1951"


         D(2).name = "Gary Beene"
         D(2).category = "Family"
         D(2).date =  "2012-11-25 10:29:00"
         D(2).flag = "1"
         D(2).node = "-"
         D(2).blog = "Home of the Dallas" + $CrLf + "Cowboys, whose stadium" + $CrLf + "is, strangely enough, not" + $CrLf + "in Dallas!" + $CrLf + "http://www.garybeene.com"

         D(3).name = "Chris Holbrook"
         D(3).category = "Co-Worker"
         D(3).date = "2012-06-22 14:41:00"
         D(3).flag = "1"
         D(3).node = "-"
         D(3).blog = "Only major country in the" + $CrLf + "world with a ferris wheel" + $CrLf + "as a major attraction!" + $CrLf + "Event: Bday 12-16-1951"

         D(4).name = "Jose Roca"
         D(4).category = "Friend"
         D(4).date =  "2012-11-25 10:29:00"
         D(4).flag = "1"
         D(4).node = "-"
         D(4).blog = "I've never understood the" + $CrLf + "bull running thing. I much" + $CrLf + "prefer the US rattlesnake" + $CrLf + "hunts!"

         D(5).name = "Patrice Terrier"
         D(5).category = "Friend"
         D(5).date = "2012-11-25 04:29:00"
         D(5).flag = "1"
         D(5).node = "-"
         D(5).blog = "The language of love is " + $CrLf + "spoken there, yes? On" + $CrLf + "everyone's travel list!"

         D(6).name = "Dave Biggs"
         D(6).category = "Aussie"
         D(6).date = "2012-08-08 16:45:00"
         D(6).flag = "1"
         D(6).node = "-"
         D(6).blog = "Ever since Opra went" + $CrLf + "down under, the country" + $CrLf + "has reached a new level" + $CrLf + "of fame!" + $CrLf + "Event: Bday 12-08-1951"
      Case %IdCancel
         Exit Sub
   End Select
   'use the array
   SortDirection = 0
   Array Sort D(1)
   LoadListViewFromD
   LoadTreeViewFromLV : SelectTVFromLV
   LoadTextBoxFromD
   FileChanged = 1 : SetDirty
End Sub

Sub DisplayFindDialog()
   If Debug Then Txt.Print FuncName$
   Local w,h As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Find", 100, -100, 330, 85, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "xsearch"
   Control Add Label, hSearch, %IDS_Label, "Find This:", 5, 10, 60, 20, %SS_Notify
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 65, 10, 180, 20
   OldProcTB_Find = SetWindowLong(GetDlgItem(hSearch,%IDS_SearchTerm), %GWL_WndProc, CodePtr(TextBoxProc_Find))   'subclass a control

   Control Add CheckBox, hSearch, %IDS_Case, "Case Sensitive", 10, 35, 125, 25
   Control Set Check hSearch, %IDS_Case, CaseSensitive
   Control Add CheckBox, hSearch, %IDS_WholeWord, "Whole Word", 10, 55, 125, 25
   Control Set Check hSearch, %IDS_WholeWord, WholeWords
   Control Add Option, hSearch, %IDS_AND, "AND", 140, 45, 50,25
   Control Add Option, hSearch, %IDS_OR, "OR", 190, 45, 40,25
   Control Add Option, hSearch, %IDS_STRING, "String", 240, 45, 60,25
   Control Add Button, hSearch, %IDS_Search, "Search", 260, 10, 56, 25
   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop While IsWindow(hSearch)
End Sub

CallBack Function SearchProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Select Case SearchMode
            Case %SearchAsString : Control Set Option hSearch, %IDS_STRING, %IDS_STRING, %IDS_OR
            Case %SearchAllTerms : Control Set Option hSearch, %IDS_AND, %IDS_STRING, %IDS_OR
            Case %SearchAnyTerm  : Control Set Option hSearch, %IDS_OR, %IDS_STRING, %IDS_OR
         End Select
         Control Set Font hSearch, %IDS_Label, hFontA
         Control Set Font hSearch, %IDS_Case, hFontA
         Control Set Font hSearch, %IDS_WholeWord, hFontA
         Control Set Font hSearch, %IDS_SearchTerm, hFontA
         Control Set Font hSearch, %IDS_Search, hFontA
         Control Set Font hSearch, %IDS_AND, hFontA
         Control Set Font hSearch, %IDS_OR, hFontA
         Control Set Font hSearch, %IDS_STRING, hFontA
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, %IDC_ListView
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_Search
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm : SearchTerm = Trim$(SearchTerm)
               FindSearchTerm
            Case %IdOk
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm : SearchTerm = Trim$(SearchTerm)
               FindSearchTerm
            Case %IdCancel
               Dialog End hSearch
            Case %IDS_Label
               If Cb.CtlMsg = %STN_DblClk Then ViewAllRecords
         End Select
      Case %WM_Destroy
         SetWindowLong hSearch, %GWL_WNDPROC, OldProcTB_Find   'un-subclass, restore original window procedure
         FindIsVisible = 0
         Control Get Check hSearch, %IDS_Case To CaseSensitive
         Control Get Check hSearch, %IDS_WholeWord To WholeWords
         Control Get Check hSearch, %IDS_STRING To iResult : If iResult Then SearchMode = %SearchAsString
         Control Get Check hSearch, %IDS_AND To iResult    : If iResult Then SearchMode = %SearchAllTerms
         Control Get Check hSearch, %IDS_OR To iResult     : If iResult Then SearchMode = %SearchAnyTerm
   End Select
End Function

Sub ViewAllRecords
   If Debug Then Txt.Print FuncName$
   Local iPos As Long
   For iPos = 1 To UBound(D) :
      If D(iPos).Flag <> "1" Then
         D(iPos).flag = "1"
         FileChanged = 1 : SetDirty
      End If
   Next iPos
   LoadListViewFromD
   LoadTreeViewFromLV : SelectTVFromLV
   LoadTextBoxFromD
   SetHeaderTitle
End Sub

Function RecordText(iPos As Long, DLimiter As String) As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   If Len(Trim$(D(iPos).name))      Then temp$ = Trim$(D(iPos).name)
   If Len(Trim$(D(iPos).category))  Then temp$ = temp$ + $Spc + Trim$(D(iPos).category)
   If Len(Trim$(D(iPos).date))      Then temp$ = temp$ + $Spc + Trim$(D(iPos).date)
   If Len(Trim$(D(iPos).blog))      Then temp$ = temp$ + $Spc + Trim$(D(iPos).blog)
   temp$ = temp$ + DLimiter + Trim$(Str$(iPos))
   Function = temp$
End Function

Sub CheckAll
   If Debug Then Txt.Print FuncName$
   Local i,iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iResult
   For i = 1 To iResult
     ListView_SetCheckState hListView, i-1, %True
   Next i
End Sub

Sub UnCheckAll
   If Debug Then Txt.Print FuncName$
   Local i,iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iResult
   For i = 1 To iResult
     ListView_SetCheckState hListView, i-1, %False
   Next i
End Sub

Sub CreateListView
   If Debug Then Txt.Print FuncName$

   Control Add ListView, hDlg, %IDC_ListView,"", 170,90,225,250,  %WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_CheckBoxes Or %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect 'Or %LVS_Ex_DoubleBuffer
   ListView Insert Column hDlg, %IDC_ListView, 1,  "Name",  wCol1,  0   'name
   ListView Insert Column hDlg, %IDC_ListView, 2, "Pos", wCol2, 0   'pos
   ListView Insert Column hDlg, %IDC_ListView, 3, "Node", wCol3, 0   'node
   SendMessage (hListView, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)

   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelistSort
End Sub

Function CDate() As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = Date$
   Function = Mid$(temp$, 7 To 10) + "-" + Left$(temp$,5) + $Spc + Time$
End Function

Sub SetDialogTitle
   If Debug Then Txt.Print FuncName$
   If FileInTitle=1 Then Dialog Set Text hDlg, "gbFreeNotes " + $ver + Space$(9) + PathName$(Namex,FileName)
   If FileInTitle=0 Then Dialog Set Text hDlg, "gbFreeNotes " + $ver
End Sub

Sub CreateComboBox
   Local ComboInfo As ComboBoxInfo, iResult As Long
   Control Add ComboBox, hDlg, %IDC_ComboBox,,100,60,120,120
   Control Handle hDlg, %IDC_ComboBox To hComboBox
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(hComboBox, ByVal VarPtr(ComboInfo))
   hComboBoxEdit = ComboInfo.hwndItem
   OldProcTB_ComboBoxEdit = SetWindowLong(hComboBoxEdit, %GWL_WndProc, CodePtr(TextBoxProc_ComboBoxEdit))   'subclass a control
   If Len(TermMRU1) Then ComboBox Set Text hDlg, %IDC_ComboBox, 1, TermMRU1
   If Len(TermMRU2) Then ComboBox Set Text hDlg, %IDC_ComboBox, 2, TermMRU2
   If Len(TermMRU3) Then ComboBox Set Text hDlg, %IDC_ComboBox, 3, TermMRU3
   If Len(TermMRU4) Then ComboBox Set Text hDlg, %IDC_ComboBox, 4, TermMRU4
   If Len(TermMRU5) Then ComboBox Set Text hDlg, %IDC_ComboBox, 5, TermMRU5
   ComboBox Find Exact hDlg, %IDC_ComboBox, 1, SearchTerm To iResult   '0 if not match
   ComboBox Select hDlg, %IDC_ComboBox, Max(iResult,1)
   Control Add Button, hDlg, %IDC_Button,"Search",300,60,50,25
End Sub

Sub CreateTreeView
   If Debug Then Txt.Print FuncName$
   Control Add Treeview, hDlg, %IDC_TreeView, "",  10, 90, 225, 250, %TVS_TrackSelect Or %TVS_HasLines Or %TVS_HasButtons Or %TVS_LinesAtRoot _
       Or %TVS_ShowSelAlways Or %WS_TabStop, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
'       Or %TVS_ShowSelAlways Or %WS_TabStop Or %TVS_EditLabels, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
   Control Handle hDlg, %IDC_TreeView To hTree
End Sub

Sub CollapseExcept
   Local hNode, hParent As Dword, temp$, iRow As Long
   ListView Get Select hDlg, %IDC_ListView To iRow
   ListView Get Text hDlg, %IDC_ListView, iRow,3 To temp$  'node in TreeView
   Treeview Get Parent hDlg, %IDC_TreeView, Val(temp$) To hParent
   'cycle through all parent nodes
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      If hNode <> hParent Then Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
End Sub

Sub CollapseAllNodes
   If Debug Then Txt.Print FuncName$
   Local hNode As Dword
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
End Sub

Sub ExpandAllNodes
   If Debug Then Txt.Print FuncName$
   Local hNode As Dword
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %True
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
End Sub

Sub DisplayRecordDialog (Title As String, iPos As Long, iSelect As Long)
   If Debug Then Txt.Print FuncName$
   LastW = 300 : LastH = 260     'client size
   If AutoPosition Then
      'set LastDX and LastDY to preferred values
      If Len(RecordHandles) = 0 Then
         LastDX = FirstDX : LastDY = FirstDY     'first View dialog
      Else
         LastDX = LastDX + 40 : LastDY = LastDY + 10    'increment to new location
      End If
   End If
   Dialog New Pixels, hDlg, Title + "   (View Only)", LastDX, LastDY, LastW, LastH, %WS_OverlappedWindow Or %WS_ClipChildren To hRecord
   RecordHandles = RecordHandles + Str$(hRecord)
   Dialog Set Icon hRecord, "logo"
   Control Add TextBox, hRecord, %IDR_blog, _
           Trim$(D(iPos).name)+$CrLf+Trim$(D(iPos).category)+$CrLf+Trim$(D(iPos).blog) , 10, 10, 230, 210, _
            %ES_Left Or %WS_Border Or %WS_TabStop Or %ES_MultiLine Or _
            %ES_AutoHScroll Or %WS_HScroll Or %ES_AutoVScroll Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Send hRecord, %IDR_Blog, %EM_SetReadOnly,%True,0
   OldProcTB_ViewOnly = SetWindowLong(GetDlgItem(hRecord,%IDR_Blog), %GWL_WndProc, CodePtr(TextBoxProc_ViewOnly))   'subclass a control
   Control Set Font hRecord, %IDR_Blog, hFontB

   'display dialog
   Dialog Show Modeless hRecord Call RecordProc()
End Sub

CallBack Function RecordProc() As Long
   Local x,y,w,h As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         KeepWIndowFullyVisibleOnDesktop Cb.Hndl
         Dialog Post Cb.Hndl, %WM_User+600, 0, 0
      Case %WM_User+600
         Control Send Cb.Hndl, %IDR_Blog, %EM_SetSel,0,0
      Case %WM_Move
         Dialog Get Loc Cb.Hndl To LastDX, LastDY   'relative to client area of hDlg
         LastDX = LastDX + Metrics(Border.X)
         LastDY = LastDY + Metrics(Border.Y) + Metrics(Caption)
      Case %WM_Command
         If Cb.Ctl = %IdCancel Then
            Dialog End Cb.Hndl
         End If
      Case %WM_Size
         Dialog Get Client Cb.Hndl To w,h
         Control Set Size Cb.Hndl, %IDR_Blog, w-20,h-20
         Dialog ReDraw Cb.Hndl
      Case %WM_SysCommand
      Case %WM_Destroy
         Replace Str$(Cb.Hndl) With $Spc In RecordHandles
         RecordHandles = RTrim$(RecordHandles)
   End Select
End Function

Sub KeepWindowFullyVisibleOnDesktop(hWin As Dword)
   Local DeskW, DeskH, EdgeMargin As Long, rc As Rect
   'parameters
   DeskW = GetSystemMetrics(%SM_CXVirtualScreen)          'desktop Width
   DeskH = GetSystemMetrics(%SM_CYVirtualScreen)          'desktop Height
   GetWindowRect hWin, rc
   If rc.nright  > DeskW-40 Then rc.nleft = DeskW - (rc.nright-rc.nleft) - %EdgeMargin
   If rc.nbottom > DeskH-40 Then rc.ntop = DeskH - (rc.nbottom-rc.ntop) - %EdgeMargin
   If rc.nleft < 40 Then rc.nleft = %EdgeMargin
   If rc.ntop  < 40 Then rc.ntop  = %EdgeMargin
   SetWindowPos( hWin, 0, rc.nleft,rc.ntop, 0, 0, %SWP_NoSize Or %SWP_NoZOrder)
End Sub

'Ascending Sorts--------------------------
' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
Function SortByNameA(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.name)<LCase$(B.name), -1, +1)
End Function

'Descending Sorts--------------------------
Function SortByNameD(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.name)<LCase$(B.name), 1, -1)
End Function

Sub SetHeaderIcons(ActiveColumn As Long)
   If Debug Then Txt.Print FuncName$
   Local i As Integer, hdi As HD_ITEM
   For i = 0 To 7 'Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right       'left is the default
      If i = ActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next i
End Sub

Sub OpenDataBase
   If Debug Then Txt.Print FuncName$
   Local temp$
   If FileChanged Then
      If AutoSave Then
         If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub 'abort save, abort OPEN
         SaveDToFile
      Else
         Select Case MsgBoxX("Current file changed. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Open Database")
            Case %IdYes
               If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub 'abort save and abort OPEN
               SaveDToFile
            Case %IdNo
               'no action. close without saving changes
            Case %IdCancel
               Exit Sub 'abort OPEN
         End Select
      End If
   End If
   temp$ = SelectFileToOpen("Open Database", %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly, Chr$("Text",0,"*.txt",0))
   If Len(temp$) Then
      FileName = temp$
      SetDialogTitle
      LoadDataFromFileToD
      ViewAllRecords
      BuildFileHistoryMenu
      FileChanged = 0 : SetDirty
   End If

End Sub

Sub NewDataBase
   If Debug Then Txt.Print FuncName$
   If FileChanged Then
      If AutoSave Then
         If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub 'abort save, abort NEW
         SaveDToFile
      Else
         Select Case MsgBoxX("Current file changed. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "New Database")
            Case %IdYes
               If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub  'abort Save and abort NEW
               SaveDToFile
            Case %IdNo
               'no action. create new database without saving changes
            Case %IdCancel
               Exit Sub 'abort NEW
         End Select
      End If
   End If
   CreateEmptyDataBase
   SetDialogTitle
   ViewAllRecords
   FileChanged = 0 : SetDirty
End Sub

Sub SaveDToFileAs
   If Debug Then Txt.Print FuncName$
   Local temp$
   If Debug Then Txt.Print FuncName$
   temp$ = SelectFileToSaveAs("Save As", %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt, Chr$("Text",0,"*.txt",0))
   If Len(temp$) Then
      If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub 'abort save
      FileName = temp$
      SetDialogTitle
      SaveDToFile
      FileChanged = 0 : SetDirty
   End If
End Sub

Function SelectFileToSaveAs(title$, flags&, filter$) As String
    If Debug Then Txt.Print FuncName$
    Local startfolder$, startfile$, defaultext$, filevar$, countvar&
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    defaultext$ = ".txt"
    startfile$ = (FileName)       'name to be used as initial selection
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$       '
End Function

Function SelectFileToOpen(title$, flags&, filter$) As String
    If Debug Then Txt.Print FuncName$
    Local startfolder$, startfile$, defaultext$, filevar$, countvar&
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$       '
End Function

Sub LoadTextBoxFromD
   If Debug Then Txt.Print FuncName$
   Local iPos,iResult As Long, temp$
   ListView Get Select hDlg, %IDC_Listview To iResult         'LV selected row
   If iResult = 0 Then
      Control Set Text hDlg, %IDC_TextBox, ""
      Exit Sub
   End If
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$ 'array POS
   iPos = Val(temp$)
   temp$ = Trim$(D(iPos).name)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).category) + $CrLf + Trim$(D(iPos).blog)
   Control Set Text hDlg, %IDC_TextBox, temp$
End Sub

Sub LoadTreeViewFromLV
   If Debug Then Txt.Print FuncName$
   Local iPos, iCount As Long, tmp$, temp$, rname$, cat$, hNode,hTemp As Dword

SendMessage hTree, %WM_SetRedraw, 0, 0
   Treeview Reset hDlg, %IDC_TreeView

   'Build root nodes
   ListView Get Count hDlg, %IDC_ListView To iCount
   For iPos = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, iPos, 2 To temp$  'Array Pos
      temp$ = Trim$(D(Val(temp$)).category)
      If InStr(LCase$(cat$), Chr$(7) + LCase$(temp$) + Chr$(7)) = 0  Then
         cat$ = cat$ + $Spc + Chr$(7) + temp$ + Chr$(7)
         Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, temp$ To hNode
      End If
   Next i
   Control Send hDlg, %IDC_TreeView, %TVM_SortChildren, %False, 0    'sort root nodes

   'Build sub-nodes
   For iPos = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, iPos, 2 To temp$  'Array pos
      temp$ = Trim$(D(Val(temp$)).category)                      'category
      ListView Get Text hDlg, %IDC_ListView, iPos, 1 To rname$   'name
      Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
      Do While hNode
         Treeview Get Text hDlg, %IDC_TreeView, hNode To tmp$  'category
         If tmp$ = temp$ Then
            Treeview Insert Item hDlg, %IDC_TreeView, hNode, %TVI_Last, 0, 0, rname$ To hTemp
            Treeview Set User hDlg, %IDC_TreeView, hTemp, iPos
            ListView Set Text hDlg, %IDC_ListView, iPos, 3, Trim$(Str$(hTemp))  'TreeView node
            Exit Do
         End If
         Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
      Loop
   Next i

  'Display Node Child Count
  'If ShowNoteCount Then LoadTreeViewFromLV

SendMessage hTree, %WM_SetRedraw, 1, 0
Control ReDraw hDlg, %IDC_TreeView

End Sub

Function TextBoxProc_Editor(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   'left disabled by choice
   Local x,y As Long
   Select Case Msg
      Case %WM_GETDLGCODE
         If lParam = %NULL Then
            y = CallWindowProc(OldProcTB_Editor, hWnd, Msg, wParam, lParam)
            Function = y Xor %DlgC_HasSetSel
            Exit Function
         End If
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB_Editor, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcTB_Editor, hWnd, Msg, wParam, lParam)
End Function

Function TextBoxProc_ComboBoxEdit(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   'left disabled by choice
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB_ComboBoxEdit, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcTB_ComboBoxEdit, hWnd, Msg, wParam, lParam)
End Function

Function TextBoxProc_Find(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   'left disabled by choice
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB_Find, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcTB_Find, hWnd, Msg, wParam, lParam)
End Function

Function TextBoxProc_ViewOnly(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   'left disabled by choice
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB_ViewOnly, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcTB_ViewOnly, hWnd, Msg, wParam, lParam)
End Function

Sub ApplyChanges
   If Debug Then Txt.Print FuncName$
   Local j,iPos, iRow As Long, hNode As Dword, temp$, tempBoho As BohoData

   'get LV Row and TreeView Node
   ListView Get Select hDlg, %IDC_ListView To iRow
   ListView Get Text hDlg, %IDC_ListView, iRow, 2 To temp$  'array pos
   iPos = Val(temp$)
   ListView Get Text hDlg, %IDC_ListView, iRow, 3 To temp$  'TreeView node
   hNode = Val(temp$)

   'get pre-Change information
   tempBoho = D(iPos)
   Control Get Text hDlg, %IDC_TextBox To temp$

   'extract information
   D(iPos).name = Parse$(temp$,$CrLf,1)
   tempBoho.category = Parse$(temp$,$CrLf,2)
   j = InStr(1,temp$,$CrLf)
   j = InStr(j+1,temp$,$CrLf)
   D(iPos).blog = Mid$(temp$,j+2)
   D(iPos).date = CDate

   'put new data in ListView
   ListView Set Text hDlg, %IDC_ListView, iRow, 1, Trim$(D(iPos).name)

   'put new data in TreeView
   If D(iPos).category <> tempBoho.category Then
      D(iPos).category = tempBoho.category
      LoadTreeViewFromLV : SelectTVFromLV
   Else
      Treeview Set Text hDlg, %IDC_TreeView, hNode, Trim$(D(iPos).name)
   End If

   'closeout
   FileChanged = 1 : SetDirty
   ShowSelectionInStatusBar
End Sub

Sub ResizeWindow
   'sideview     'categoryview      'hide datepos
   If Debug Then Txt.Print FuncName$
   Local w,h As Long
   Dialog Get Client hDlg To w,h

   If EqualSize Then
      Control Set Loc hDlg, %IDC_Button, w/2 - 53,60
      Control Set Size hDlg, %IDC_ComboBox, (w-40)/2 - 140,120

      Control Set Size hDlg, %IDC_TreeView, (w-40)/4, h-120
      Control Set Loc hDlg, %IDC_ListView, (w-40)/4 + 20,90
      Control Set Size hDlg, %IDC_ListView, (w-40)/4, h-120
      Control Set Loc hDlg, %IDC_TextBox, w/2 + 10, 60
      Control Set Size hDlg, %IDC_TextBox, w/2 - 20, h-90
      ListView Set Column hDlg, %IDC_ListView, 1, (w-40)/4-5

   Else
      If WideControls Then
         Control Set Loc hDlg, %IDC_Button, 270,60
         Control Set Size hDlg, %IDC_ComboBox, 160,120

         Control Set Loc hDlg, %IDC_TextBox, 480,60
         Control Set Size hDlg, %IDC_TextBox, w-490,h-90
         Control Set Loc hDlg, %IDC_ListView, 245,90
         Control Set Size hDlg, %IDC_ListView, 225,h-120
         Control Set Size hDlg, %IDC_TreeView,225,h-120
         ListView Set Column hDlg, %IDC_ListView, 1, 220
     Else
         Control Set Loc hDlg, %IDC_Button, 270,60
         Control Set Size hDlg, %IDC_ComboBox, 160,120

         Control Set Loc hDlg, %IDC_TextBox, 330,60
         Control Set Size hDlg, %IDC_TextBox, w-340,h-90
         Control Set Loc hDlg, %IDC_ListView, 170,90
         Control Set Size hDlg, %IDC_ListView, 150,h-120
         Control Set Size hDlg, %IDC_TreeView,150,h-120
         ListView Set Column hDlg, %IDC_ListView, 1, 145
     End If
   End If
End Sub

Sub FindSearchTerm
   If Debug Then Txt.Print FuncName$
   Local j, iPos,iCount,iResult As Long, sTerm$, text$
   If SearchTerm = "..all" Then ViewAllRecords : Exit Sub

   Control Get Check hSearch, %IDS_Case To CaseSensitive
   Control Get Check hSearch, %IDS_WholeWord To WholeWords

   If CaseSensitive = 0 Then sTerm$ = LCase$(SearchTerm) Else sTerm$ = SearchTerm

   Control Get Check hSearch, %IDS_STRING To iResult : If iResult Then SearchMode = %SearchAsString
   Control Get Check hSearch, %IDS_AND To iResult    : If iResult Then SearchMode = %SearchAllTerms
   Control Get Check hSearch, %IDS_OR To iResult     : If iResult Then SearchMode = %SearchAnyTerm

    'allow ANDOR
    If AllowANDOR Then
       If InStr(LCase$(sTerm$), " and ") Then
          Replace " and " With " " In sTerm$
          SearchMode = %SearchALLTerms
          Control Set Check hSearch, %IDS_AND, %True
          SetMenus
       End If
       If InStr(LCase$(sTerm$), " or ") Then
          Replace " or " With " " In sTerm$
          SearchMode = %SearchAnyTerm
          Control Set Check hSearch, %IDS_OR, %True
          SetMenus
       End If
    End If

    'create search term list in array T().
    If SearchMode = %SearchAsString Then
        'use as one long term. spaces are not removed, nor trimmed from ends of search string
        ReDim T(0) As String
        T(0) = sTerm$
    Else
        'search all terms or all terms, so split into multiple terms on $SPC
        sTerm$ = Shrink$(sTerm$)        'remove contiguous, start/end spaces
        ReDim T(ParseCount(sTerm$, " ")-1) As String                             'create array of terms
        Parse sTerm$, T(), " "
    End If

   'set all record to NOT display
   For iPos = 1 To UBound(D) : D(iPos).flag = "-" : Next iPos

   'search
   For iPos = 1 To UBound(D)
      If CaseSensitive Then text$ = RecordText(iPos,$Spc) Else text$ = LCase$(RecordText(iPos,$Spc))

      Select Case SearchMode
         Case %SearchAsString   '= on toolbar - Complete String
            iResult = InStrW(text$,sterm$)
            If iResult Then D(iPos).flag = "1" Else D(iPos).flag = "-"

         Case %SearchAnyTerm   'OR on toolbar - Any Word in the document
            iResult = 0
            For j = 0 To UBound(T)
               If InStrW(text$,T(j)) Then iResult = 1 : Exit For
            Next j
            If iResult Then D(iPOs).flag = "1" Else D(iPos).flag = "-"

         Case %SearchAllTerms  'AND on toolbar -  'All Words somewhere in document OR all on one line if WordsOnLine=1
            'does file have all the words in it
            iResult = 1
            For j = 0 To UBound(T)
               If InStrW(text$,T(j)) = 0  Then iResult = 0 : Exit For
            Next j
            If iResult Then D(iPos).flag = "1" Else D(iPos).flag = "-"
      End Select
   Next iPos

   LoadListViewFromD
   LoadTreeViewFromLV : SelectTVFromLV
   LoadTextBoxFromD
   FileChanged = 1 : SetDirty
   SetHeaderTitle
   Statusbar Set Text hDlg, %IDC_Toolbar, 1,0, "Matching Notes: " + Str$(iCount)
End Sub

Sub SelectTVFromLV
   If Debug Then Txt.Print FuncName$
   Local temp$, iPos As Long
   ListView Get Select hDlg, %IDC_Listview To iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 3 To temp$  'TreeView node
   Treeview Select hDlg, %IDC_TreeView, Val(temp$)
   SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
End Sub

Sub SendEmail
   If Debug Then Txt.Print FuncName$
   Local iReturn As Long, temp$, tmp$, iStart,iLength As Long
   Control Get Text hDlg, %IDC_TextBox To temp$
   tmp$ = "([a-z0-9._/+-]+)(@[a-z0-9.-]+)"
   RegExpr tmp$ In temp$ To iStart, iLength
   If iStart = 0 Then
      Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "No email address found ..."
      Beep : Exit Sub
   End If
   temp$ = Mid$(temp$, iStart, iLength)
   iReturn = ShellExecute(hDlg, "Open", "mailto:" + temp$ , $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub OpenSearch
   If Debug Then Txt.Print FuncName$
   Local temp$, iStartPos, iEndPos, cID As Long, hWin As Dword
   hWin = GetParent(GetFocus)
   cID = GetDlgCtrlID(GetFocus)
   Control Get Text hWin, cID To temp$
   Control Send hWin, cID, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   If Len(temp$) Then
      SearchTerm = temp$
      Control Set Text hDlg, %IDC_ComboBox, SearchTerm
      FindSearchTerm
   End If
End Sub

Sub OpenURL
   If Debug Then Txt.Print FuncName$
   Local temp$, iResult, iStartPos, iEndPos, cID As Long, hWin As Dword
   hWin = GetParent(GetFocus)
   cID = GetDlgCtrlID(GetFocus)
   Control Get Text hWin, cID To temp$
   Control Send hWin, cID, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub OpenEmail
   If Debug Then Txt.Print FuncName$
   Local temp$, iResult, iStartPos, iEndPos, cID As Long, hWin As Dword
   hWin = GetParent(GetFocus)
   cID = GetDlgCtrlID(GetFocus)
   Control Get Text hWin, cID To temp$
   Control Send hWin, cID, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   iResult = ShellExecute(hDlg, "Open", "mailto:" + temp$ , $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub BackupDataBase
   If Debug Then Txt.Print FuncName$
   If IsFolder (Exe.Path$ + "backup") = %False Then MkDir Exe.Path$ + "backup"
   Local temp$
   temp$ = "backup\" + CDate + " " + PathName$(Namex,FileName)
   Replace Any ": -" With "___" In temp$
   If IsFile(FileName) Then
      FileCopy FileName, Exe.Path$ + temp$
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Backup made of ... " + FileName
   Else
      Beep
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Backup failed. File not found: " + FileName
   End If
End Sub

Function InstanceTest() As Long
   If Debug Then Txt.Print FuncName$
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As WStringZ * %Max_Path, hTry As Dword
   UniqueName = "gbFreeNotes"
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 Or GetLastError = %ERROR_ALREADY_EXISTS Then
      hTry = GeTTopWindow(%HWND_Desktop)
      Do While hTry
         If GetWindowLong(hTry, %GWL_UserData) = %UniqueNumber Then Exit Do
         hTry = GetWindow(hTry, %GW_HWNDNEXT)
      Loop
      If hTry Then
         ShowWindow(hTry, %SW_Restore)
         ShowWindow(hTry, %SW_Show)
         SetForegroundWindow(hTry)
      End If
      Beep
      Function = 0
   Else
      Function = 1
   End If
End Function

Function InstrW(smain$,sterm$) As Long
'    If Debug Then Txt.Print FuncName$    '<--- turned off by choice
    Local iPos,FlagLeft,FlagRight As Long, rChar$, lChar$

    'find sterm$ (not the whole word version)
    iPos = InStr(smain$, sterm$)
    If WholeWords = 0 Then Function = iPos : Exit Function

    Do While iPos
        FlagLeft = %False : FlagRight = %False
        'check left side
        If iPos = 1 Then
            FlagLeft = %True                   'flush with left side of line
        Else
            lChar$ = Mid$(smain$,iPos-1,1)
            FlagLeft = IsTrue(Verify(lChar$, ValidWordCharacters))
        End If
        'check right side
        If iPos = Len(smain$)-Len(sTerm$)+1 Then
            FlagRight = %True                 'flush with right side of line
        Else
            rChar$ = Mid$(smain$,iPos + Len(sterm$),1)
            FlagRight = IsTrue(Verify(rChar$, ValidWordCharacters))
        End If
        'Done?
        If FlagLeft And FlagRight Then Exit Do
        iPos = InStr(iPos+Len(sterm$), smain$, sterm$)
    Loop
    Function = iPos
End Function

Function GetPSW(title$) As Long
   If Debug Then Txt.Print FuncName$
   Local temp$, x,y As Long
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   CenterOverDialog(300,90,x,y)
   temp$ = InputBox$("", title$ + " ... Enter password:", PSW,x,y)
   If Len(temp$) Then PSW = temp$ : Function = 1
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$    '<--- turned off by choice
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 170                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 20   : @cst.cy = -50          'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 150 : @cst.y = @cst.y - 140  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 265 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Function EncryptText(text$, Psw$) As String    'Beene
   If Debug Then Txt.Print FuncName$
   Local i,a As Long, temp$
   temp$ = text$
   For i = 1 To Len(text$)
      a = (i Mod Len(Psw$)) + 1        'Joseph Cote
      Mid$(temp$,i) =  (Chr$(i Xor Asc(Mid$(Psw$,a,1)) Xor Asc(Mid$(text$,i,1))))
   Next i
   Function = temp$
End Function

Sub CreateEmptyDataBase
   If Debug Then Txt.Print FuncName$
   ReDim D(0)
   D(0).name = "-"
   D(0).category = "-"
   D(0).flag = "-"
   D(0).node = "-"
   D(0).date = "-"
   D(0).blog = "-"

   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Empty dataBase created ..."
   FileName = Exe.Path$ + "NoName.txt"
   FileChanged = 0 : SetDirty
End Sub

Sub LoadDataFromFileToD
   If Debug Then Txt.Print FuncName$
   Local i,j,iPos As Long, FirstByte As String * 1, temp$
   If IsTrue(IsFile(FileName)) Then
      Open FileName For Binary As #1 : Get$ #1,1, FirstByte : Close #1
      If FirstByte = Chr$(7) Then
         If GetPSW("Open File") Then
            Open FileName For Binary As #1
            Get$ #1, 1, FirstByte
            Get$ #1, Lof(1)-1, BigString
            BigString = EncryptText(BigString,PSW)
            ReDim D(0 To (Lof(1)-1) / Len(BohoData) - 1)
            Close #1
            For i = 0 To UBound(D)
               iPos = i * Len(BohoData) + 1 : D(i).name = Mid$(BigString, iPos, 50)
               iPos = iPos + 50        : D(i).category = Mid$(BigString, iPos, 50)
               iPos = iPos + 50         : D(i).date = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).date = Mid$(BigString, iPos, 15)
               iPos = iPos + 15         : D(i).flag = Mid$(BigString, iPos, 1)
               iPos = iPos + 1          : D(i).blog = Mid$(BigString, iPos, 5000)
            Next i
         Else
            Beep
            CreateEmptyDataBase
         End If
      Else
         Open FileName For Binary As #1
         Get$ #1, Lof(1), temp$
         Close #1
         Dim tempD(ParseCount(temp$,$Delimiter)-1) As String
         ReDim D(UBound(tempD))
         Parse temp$, tempD(), $Delimiter
         For i = 0 To UBound(tempD)
            D(i).name = Parse$(tempD(i),$CrLf,1)
            D(i).category = Parse$(tempD(i),$CrLf,2)
            D(i).date = Parse$(tempD(i),$CrLf,3)
            D(i).flag = Parse$(tempD(i),$CrLf,4)
            j = InStr(1,tempD(i),$CrLf) : j = InStr(j+2,tempD(i),$CrLf)
            j = InStr(j+2,tempD(i),$CrLf) : j = InStr(j+2,tempD(i),$CrLf)
            D(i).blog = Mid$(tempD(i),j+2)
         Next i
      End If
   Else
      CreateEmptyDataBase
   End If
End Sub

Sub SaveDToFile
   If Debug Then Txt.Print FuncName$
   Local i As Long, temp$
   If SaveEncrypted Then
      'special save approach
      If IsFile(FileName) Then Kill FileName
      Open FileName For Binary As #1
      For i = 0 To UBound(D) : temp$ = temp$ + D(i) : Next i
      temp$ = EncryptText(temp$, PSW)
      temp$ = Chr$(7) + temp$
      Put$ #1,temp$
      Close #1
   Else
      Open FileName For Output As #1
      For i = 0 To UBound(D)
         If i Then Print #1, $Delimiter;    '1st line of database is NOT $Delimiter
         Print #1, Trim$(D(i).name)
         Print #1, Trim$(D(i).category)
         Print #1, Trim$(D(i).date)
         Print #1, Trim$(D(i).flag)
         If i = UBound(D) Then
            Print #1, RTrim$(D(i).blog, Any $Spc + $CrLf);
         Else
            Print #1, RTrim$(D(i).blog, Any $Spc + $CrLf)
         End If
      Next i
      Close #1
   End If
   BuildFileHistoryMenu
   FileChanged = 0 : SetDirty
End Sub

Sub DisplayEvents
   If Debug Then Txt.Print FuncName$
   Local yesterday$, today$, nextweek$, tmp$,temp$, ename$, edate$
   Local i,j,iPos As Long
   For iPos = 1 To UBound(D)
      If InStr(D(iPos).blog,"Event:") Then
         For i = 1 To ParseCount(D(iPos).blog,$CrLf)   '# line in .blog field
            tmp$ = Parse$(D(iPos).blog,$CrLf,i)        'current line
            If InStr(tmp$,"Event:") Then
               For j = 1 To ParseCount(tmp$,$Spc)
                  If Parse$(tmp$,$Spc,j) = "Event:" Then
                     ename$ = Trim$(Parse$(tmp$,Any $Spc + $CrLf,2))
                     edate$ = Trim$(Parse$(tmp$,Any $Spc + $CrLf,3))
                     Select Case DayDifference(edate$)
                        Case -5 To -1 : yesterday$ = yesterday$ + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
                        Case 1 To 5   : nextweek$  = nextweek$  + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
                        Case 0        : today$     = today$     + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
                     End Select
                     j = j + 2
                  End If
               Next j
            End If
         Next i
      End If
   Next iPos

   temp$ =       "Prior 5 days:" + IIf$(Len(yesterday$), yesterday$, $CrLf + "   " + "none") _
         + $CrLf + $CrLf + "Today:" + IIf$(Len(today$), today$, $CrLf + "   " + "none") _
         + $CrLf + $CrLf + "Next 5 days:" + IIf$(Len(nextweek$),nextweek$,$CrLf + "   " + "none")
   MsgBoxX temp$, %MB_Ok + %MB_IconInformation, "Events"
End Sub

Function DayDifference(eDate$) As Long
   If Debug Then Txt.Print FuncName$
   Local y1,m1,d1, y2,m2,d2 As Long, day2, day1 As Double
   m1 = Val(Left$(Date$,2))  : d1 = Val(Mid$(Date$,4,2))  : y1 = Val(Right$(Date$,4))
   m2 = Val(Left$(eDate$,2)) : d2 = Val(Mid$(eDate$,4,2)) : y2 = y1   'Val(Right$(eDate$,4))

   day1 = y1 + (m1 - 2.85) / 12
   day1 = Int(Int(Int(367 * day1) - 1.75 * Int(day1) + d1) -0.75 * Int(0.01 * day1)) + 1721119

   day2 = y2 + (m2 - 2.85) / 12
   day2 = Int(Int(Int(367 * day2) - 1.75 * Int(day2) + d2) -0.75 * Int(0.01 * day2)) + 1721119

   Function = Int(day2) - Int(day1)
End Function

Sub BuildFileHistoryMenu
   If Debug Then Txt.Print FuncName$

   Menu Delete hPopupFile, 6
   Menu Delete hPopupFile, ByCmd %IDM_FileMRU1
   Menu Delete hPopupFile, ByCmd %IDM_FileMRU2
   Menu Delete hPopupFile, ByCmd %IDM_FileMRU3
   Menu Delete hPopupFile, ByCmd %IDM_FileMRU4
   Menu Delete hPopupFile, ByCmd %IDM_FileMRU5

   If FileName = FileMRU1 Then
      'nothing
   ElseIf FileName = FileMRU2 Then
      FileMRU2 = FileMRU1 : FileMRU1 = FileName
   ElseIf FileName = FileMRU3 Then
      FileMRU3 = FileMRU2 : FileMRU2 = FileMRU1 : FileMRU1 = FileName
   ElseIf FileName = FileMRU4 Then
      FileMRU4 = FileMRU3 : FileMRU3 = FileMRU2 : FileMRU2 = FileMRU1 : FileMRU1 = FileName
   Else
      FileMRU5 = FileMRU4 : FileMRU4 = FileMRU3 : FileMRU3 = FileMRU2 : FileMRU2 = FileMRU1 : FileMRU1 = FileName
   End If

   If IsFile(FileMRU1) Then
      Menu Add String, hPopupFile, "-", %IDM_Sep, %MF_Enabled
      If IsFile(FileMRU1) Then Menu Add String, hPopupFile, FileMRU1, %IDM_FileMRU1, %MF_Enabled
      If IsFile(FileMRU2) Then Menu Add String, hPopupFile, FileMRU2, %IDM_FileMRU2, %MF_Enabled
      If IsFile(FileMRU3) Then Menu Add String, hPopupFile, FileMRU3, %IDM_FileMRU3, %MF_Enabled
      If IsFile(FileMRU4) Then Menu Add String, hPopupFile, FileMRU4, %IDM_FileMRU4, %MF_Enabled
      If IsFile(FileMRU5) Then Menu Add String, hPopupFile, FileMRU5, %IDM_FileMRU5, %MF_Enabled
   End If
End Sub

Sub TakeFileMRUAction(cID As Long)
   If Debug Then Txt.Print FuncName$
   Local temp$
   If FileChanged Then
      If AutoSave Then
         If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub  'abort SAVE, abort FileMRUAction
         SaveDToFile
      Else
         Select Case MsgBoxX("Current file has changes. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Open Database")
            Case %IdYes
               If SaveEncrypted And GetPSW("Save File")=0 Then Exit Sub 'abort SAVE, abourt FileMRUAction
               SaveDToFile
            Case %IdNo
               'no action. open without saving changes
            Case %IdCancel
               Exit Select
         End Select
      End If
   End If
   Menu Get Text hPopupFile, ByCmd cID To temp$
   If IsFile(temp$) Then
      FileName = temp$
      SetDialogTitle
      LoadDataFromFileToD
      ViewAllRecords
      BuildFileHistoryMenu
      FileChanged = 0 : SetDirty
   End If
End Sub

Sub ComboBoxSet_Beene
   Local i, iResult As Long
   Control Get Text hDlg, %IDC_ComboBox To SearchTerm
   ComboBox Insert hDlg, %IDC_ComboBox, 1, SearchTerm
   ComboBox Find Exact hDlg, %IDC_ComboBox, 2, SearchTerm To iResult
   If iResult Then ComboBox Delete hDlg, %IDC_ComboBox, iResult
   ComboBox Get Count hDlg, %IDC_ComboBox To iResult
   For i = iResult To 6
      ComboBox Delete hDlg, %IDC_Combobox, i
   Next i
End Sub

Sub ComboboxSet_Pierre
   Local sNewItem, sBuffer As String, ComboItemCount As Dword, Looper As Long

   sNewItem = Nul$(SendMessage(hCombobox, %WM_GETTEXTLENGTH, 0, 0)) 'Create a buffer to get edit part of combo
   SendMessage(hCombobox, %WM_GETTEXT, 1 + Len(sNewItem), StrPtr(sNewItem)) 'Get text from edit part of combo

   If Len(sNewItem) Then 'Check if item is not nul
      SendMessage(hCombobox, %CB_INSERTSTRING, 0, StrPtr(sNewItem)) 'Insert item at top
      ComboItemCount = SendMessage(hCombobox, %CB_GETCOUNT, 0, 0)   'Get combo item count
      If ComboItemCount > 1 Then
         For Looper = 1 To ComboItemCount - 1 'Start with second item, item are zero based
            sBuffer = Nul$(SendMessage(hCombobox, %CB_GETLBTEXTLEN, Looper, 0) + 1) 'Create a buffer
            SendMessage(hCombobox, %CB_GETLBTEXT, Looper, StrPtr(sBuffer)) 'Get text item in buffer
            sBuffer = Left$(sBuffer, Len(sBuffer) - 1) 'Remove last $NULL
            If UCase$(sBuffer) = UCase$(sNewItem) Then 'Is new item already exist, any upper-lower case
               SendMessage(hCombobox, %CB_DELETESTRING, Looper, 0) 'Yes, delete it
               Exit For 'We are done
            End If
         Next
         If ComboItemCount > 5 Then 'Limit the maximum items in combo
            For Looper = 5 - 1 To ComboItemCount - 1
               SendMessage(hCombobox, %CB_DELETESTRING, 5, 0) 'Delete surplus items
            Next
         End If
      End If
   End If
   SendMessage(hCombobox, %CB_SETCURSEL, 0, 0) 'Highlight text in the edit control
End Sub

Sub PrintSelectionOrAll
   Local temp$, i, iStartPos, iEndPos As Long
   Control Get Text hDlg, %IDC_TextBox To temp$
   Control Send hDlg, %IDC_TextBox, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   If iStartPos <> iEndPos Then
      temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   End If
   XPrint Attach Default
   XPrint
   XPrint
   For i = 1 To ParseCount(temp$,$CrLf)
      XPrint Parse$(temp$,$CrLf,i)
   Next i
   XPrint Close
End Sub

Sub CopySelectionOrAll
   Local temp$, iStartPos, iEndPos As Long
   Control Get Text hDlg, %IDC_TextBox To temp$
   Control Send hDlg, %IDC_TextBox, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   If iStartPos <> iEndPos Then
      temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   End If
   Clipboard Reset
   Clipboard Set Text temp$
End Sub

Sub SetDirty
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_File
   If FileChanged Then
      'dirty
      Toolbar Add Button hDlg, %IDC_Toolbar, 15, %IDT_File,  %TbStyle_Button Or %TbStyle_DropDown, "File" At 1
   Else
      'clean
      Toolbar Add Button hDlg, %IDC_Toolbar, 16, %IDT_File,  %TbStyle_Button Or %TbStyle_DropDown, "File" At 1
   End If
End Sub

Sub DisplayCount
   If Debug Then Txt.Print FuncName$
   Local hNode As Dword, temp$, buffer$, iCount, iTotal As Long
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
      iCount = TreeGetNodeChildCount(hNode)
      iTotal = iTotal + iCount
      buffer$ = buffer$ + $CrLf + temp$ + "   (" + Trim$(Str$(iCount)) + ")"
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
   buffer$ = buffer$ + $CrLf + $CrLf + "Total Notes: " + Str$(iTotal)
   MsgBoxX buffer$, %MB_Ok + %MB_IconInformation + %MB_TaskModal, "Category Note Counts"
End Sub

Function TreeGetNodeChildCount(ByVal hNode As Dword) As Long
   Local iCount As Long
   Treeview Get Child hDlg, %IDC_TreeView, hNode To hNode
   While hNode
      Incr iCount
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Wend
   Function = iCount
End Function

Sub SetHeaderTitle
   Local iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount < UBound(D) Then
      ListView Set Header hDlg, %IDC_ListView, 1, "Name   (*" + Trim$(Str$(iCount)) + ")  "
   Else
      ListView Set Header hDlg, %IDC_ListView, 1, "Name   (" + Trim$(Str$(iCount)) + ")  "
   End If
End Sub



Sub DisplayAllEvents
   If Debug Then Txt.Print FuncName$
   Local tmp$,hAllEvents As Dword, iRow As Long

   Dialog New Pixels, hDlg, "All Events:", 150,150,350,250, %WS_SysMenu To hAllEvents
   Dialog Set Icon hAllEvents, "logo"

   Control Add ListView, hAllEvents, %IDC_Events,"", 0,0,350,250,  %WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   ListView Set StyleXX hAllEvents, %IDC_Events, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   ListView Insert Column hAllEvents, %IDC_Events, 1,  "Name",  140,  0
   ListView Insert Column hAllEvents, %IDC_Events, 2, "Event",  110, 0
   ListView Insert Column hAllEvents, %IDC_Events, 3, "Date",   100, 0
   ListView Insert Column hAllEvents, %IDC_Events, 4, "Pos",   0, 0
   Control Set Font hAllEvents, %IDC_Events, hFontB

   Local i,j,iPos As Long
   For iPos = 1 To UBound(D)
      If InStr(D(iPos).blog,"Event:") Then
         For i = 1 To ParseCount(D(iPos).blog,$CrLf)   '# line in .blog field
            tmp$ = Parse$(D(iPos).blog,$CrLf,i)        'current line
            If InStr(tmp$,"Event:") Then
               For j = 1 To ParseCount(tmp$,$Spc)
                  If Parse$(tmp$,$Spc,j) = "Event:" Then
                     Incr iRow
                     ListView Insert Item hAllEvents, %IDC_Events, iRow, 1, Trim$(D(iPos).name)
                     ListView Set Text hAllEvents, %IDC_Events, iRow, 2, Trim$(Parse$(tmp$,$Spc,j+1))
                     ListView Set Text hAllEvents, %IDC_Events, iRow, 3, Trim$(Parse$(tmp$,$Spc,j+2))
                     ListView Set Text hAllEvents, %IDC_Events, iRow, 4, Str$(iPos)
                     j = j + 2
                  End If
               Next j
            End If
         Next i
      End If
   Next iPos
   Dialog Set Text hAllEvents, "gbFreeeNotes Events:  (" + Trim$(Str$(iRow)) + ")"
   Dialog Show Modal hAllEvents Call EventsProc()
End Sub

CallBack Function EventsProc() As Long
   Local iResult As Long, LVData As NM_ListView, temp$
   Select Case Cb.Msg
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_Events
               Select Case Cb.NmCode
                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     EventSortDirection = EventSortDirection Xor 1
                     If EventSortDirection Then
                        If LVData.iSubItem+1 = 1 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Ascend
                        If LVData.iSubItem+1 = 2 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Ascend
                        If LVData.iSubItem+1 = 3 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Ascend
                     Else
                        If LVData.iSubItem+1 = 1 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Descend
                        If LVData.iSubItem+1 = 2 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Descend
                        If LVData.iSubItem+1 = 3 Then ListView Sort Cb.Hndl, %IDC_Events, LVData.iSubItem+1, Descend
                     End If
                  Case %NM_DblClk
                     ListView Get Select Cb.Hndl, %IDC_Events To iResult
                     ListView Get Text Cb.Hndl, %IDC_Events, iResult, 4 To temp$
                     iResult = Val(temp$)
                     ViewAllRecords
                     ListView Select hDlg, %IDC_ListView, iResult
                     ListView Visible hDlg, %IDC_ListView, iResult
                     ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                     Dialog End Cb.Hndl
                     Dialog Post hDlg, %WM_User+501, 0, 0
               End Select
         End Select
   End Select
End Function

Sub CreateBookmark
   Local iResult As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$   'array POS
   iResult = Val(temp$)
   If InStr(D(iResult).blog, ":Bookmark:") = 0 Then
      D(iResult).blog = Trim$(D(iResult).blog) + $CrLf + ":Bookmark:"
      LoadTextBoxFromD
      FileChanged = 1
   End If
End Sub

Sub ShowBookmarks
   Control Set Text hDlg, %IDC_ComboBox, ":Bookmark:"
   FindSearchTerm
End Sub

Sub RemoveAllBookmarks
   Local i As Long
   For i = 1 To UBound(D)
      Replace $CrLf + ":Bookmark:" With $Spc In D(i).blog
      Replace ":Bookmark:" With $Spc In D(i).blog
   Next i
   FileChanged = 1
   LoadTextBoxFromD
End Sub
